# sitelib for noarch packages, sitearch for others (remove the unneeded one)
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: Generic C++ interface for a DAQ system
Name: daqpp
Version: 1.6.0
Release: 1
License: GPL
Group: Development/Libraries
Source: %{name}-%{version}-%{release}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Packager: Carlos Lacasta <Carlos.Lacasta@ific.uv.es>
BuildRequires:  python-devel

%description
This package provides a generic C++ interface of a data acquisiton system.

%package devel
Summary: Libraries, includes, etc. for DAQ++
Group: Development/Libraries
Requires: %{name} = %{version}

%description devel
ditto

#%package doc
#Group: Documentation
#Summary: Documentation for DAQ++

#%description doc
#Documentation for DAQ++

%prep
%setup -q -n %{name}-%{version}-%{release}

%build
echo $RPM_BUILD_ROOT

%configure --disable-rpath --disable-static
# a fix to remove rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool


make %{?_smp_mflags}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

#
# Make cleaned-up versions of tutorials, examples, and faq for installation
#
./scripts/mkinstalldirs tmpdocs
./scripts/mkinstalldirs tmpdocs/python
./scripts/mkinstalldirs tmpdocs/test

dir=test
file_list="\
daq.cc	 DataLogger.cc	DataLogger.h \
Histogram.cc Histogram.h \
MyModule.cc	     MyModule.h		 random.c	  random.h \
README		     simpleDAQ.cc	 SimpleModule.cc  SimpleModule.h \
SimpleRunManager.cc  SimpleRunManager.h  Trigger.cc \
Trigger.h	     tstfifo.cc		 tstmonitor.cc	  tstparam.cc \
tsttrigger.cc	     utils.cc		 utils.h\
"

if [ -d $dir ] ; then
   ./scripts/mkinstalldirs tmpdocs/$dir
   for file in $file_list; do
      install -m 0644 $dir/$file tmpdocs/$dir
   done
fi

dir=python
file_list="\
dbgModule.py	 gtktools.py	    loadingPythonModule.cc  \
 MyModule.cc	    MyModule.h		    python_cflags.py \
PythonLoader.cc  PythonLoader.h     simpleDAQ.py
simpleModule.py  simpleMonitor.py   simpleRunManager.py     testBuffer.py
testDAQ.py	 testFifo.py	    testFileIO.py	    testGTimer.py
testGtk.py	 testMisc.py	    testModuleLoad.py	    testModule.py
testParam.py	 testRunManager.py  testRunState.py	    UserMakefile
"

if [ -d $dir ] ; then
   ./scripts/mkinstalldirs tmpdocs/$dir
   for file in $file_list; do
      install -m 0644 $dir/test/$file tmpdocs/$dir
   done
fi


%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)

%doc AUTHORS ChangeLog COPYING NEWS README  
%doc tmpdocs/python
%doc tmpdocs/test
%{_datadir}/doc/%{name}-%{version}/html
%{_datadir}/doc/%{name}-%{version}/python-doc
%{_libdir}/lib*.so.*
%{python_sitearch}/daqpp/

%files devel
%defattr(-, root, root)

%doc AUTHORS ChangeLog NEWS README COPYING 

%{_bindir}/DAQ++-config
%{_libdir}/lib*.so
%{_libdir}/*a
%{_libdir}/pkgconfig/DAQ++.pc
%{_libdir}/pkgconfig/daqpp-soap-server.pc
%{_libdir}/pkgconfig/daqpp-soap-client.pc
%{_includedir}/*
%{_datadir}/aclocal/daq++.m4

				   
#%files doc
#%defattr(-, root, root)
#%doc doc/html

