/* -*- mode: c++ -*- */
#ifndef __DAQpp_RunCommand_h__
#define __DAQpp_RunCommand_h__

#include <DAQ++/ObserverModel.h>
#include <DAQ++/exception.h>

namespace DAQpp
{
/**
     *  \brief class RunCommand.   
     *  \ingroup DAQ
     *  
     *  This class distributes the commands among the modules in a RunManager
     *
     *   \author Carlos Lacasta
*/
class RunCommand : public Observable
{
public:
    /// Constructor
    RunCommand()
    {}
    /// Destructor
    virtual ~RunCommand()
    {}
    /// Possible commands
    enum CommandType {
        getready,
        initrun,
        run,
        stop,
        pauserun,
        resume,
        trigger,
        send_reset,
        gettingready
    };

    /// commands
            void send_command(CommandType cmd);
};
}
#endif
