/*
 * daqppService.h
 *
 *  Created on: 4 Jan 2011
 *      Author: lacasta
 */

#ifndef DAQPPSERVICE_H_
#define DAQPPSERVICE_H_
#include <DAQ++/soap/soapdaqppSOAPService.h>
#include <DAQ++/soap/MsgManager.h>

class daqppService: public daqppSOAPService
{
    private:
        void init_service();
        DAQpp::MsgManager *mngr;
    public:
        /// Constructor
        daqppService();
        /// Constructor with copy of another engine state
        daqppService(const struct soap&);
        /// Constructor with engine input+output mode control
        daqppService(soap_mode iomode);
        /// Constructor with engine input and output mode control
        daqppService(soap_mode imode, soap_mode omode);

        /// Web service operation 'getModuleList' (returns error code or SOAP_OK)
        int getModuleList(int getModuleListRequest, struct ns1__getModuleListResponse &_param_1);

        /// Web service operation 'getRunManagerList' (returns error code or SOAP_OK)
        int getRunManagerList(int getRunManagerListRequest, struct ns1__getRunManagerListResponse &_param_2);

        /// Web service operation 'getParameterNames' (returns error code or SOAP_OK)
        int getParameterNames(std::string getParameterNamesRequest, struct ns1__getParameterNamesResponse &_param_3);

        /// Web service operation 'getStatus' (returns error code or SOAP_OK)
        int getStatus(std::string getStatusRequest, struct ns1__getStatusResponse &_param_4);

        /// Web service operation 'getParameter' (returns error code or SOAP_OK)
        int getParameter(ns1__ParameterID *getParameterRequest, struct ns1__getParameterResponse &_param_5);

        /// Web service operation 'setParameter' (returns error code or SOAP_OK)
        int setParameter(ns1__Parameter *setParameterRequest, int &setParameterResponse);

        /// Web service operation 'activateRunManager' (returns error code or SOAP_OK)
        int activateRunManager(std::string activateRMRequest, int &activateRMResponse);

        /// Web service operation 'StartRunManager' (returns error code or SOAP_OK)
        int StartRunManager(std::string StartRunManagerRequest, int &StartRunManagerResponse);

        /// Web service operation 'StopRunManager' (returns error code or SOAP_OK)
        int StopRunManager(std::string StopRunManagerRequest, int &StopRunManagerResponse);

        /// Web service operation 'GetReady' (returns error code or SOAP_OK)
        int GetReady(std::string GetReadyRequest, int &GetReadyResponse);

        /// Web service operation 'Pause' (returns error code or SOAP_OK)
        int Pause(std::string PauseRequest, int &PauseResponse);

        /// Web service operation 'Continue' (returns error code or SOAP_OK)
        int Continue(std::string ContinueRequest, int &ContinueResponse);

        /// Web service operation 'Reset' (returns error code or SOAP_OK)
        int Reset(std::string ResetRequest, int &ResetResponse);

        /// Web service operation 'setMaxEvents' (returns error code or SOAP_OK)
        int setMaxEvents(ns1__MaxEvents *setMaxEventsRequest, int &setMaxEventsResponse);

        /// Web service operation 'getMonitorData' (returns error code or SOAP_OK)
        int getMonitorData(std::string getMonitorDataRequest, xsd__base64Binary &getMonitorDataResponse);

        /// Web service operation 'stopServer' (returns error code or SOAP_OK)
        int stopServer(int stopServerRequest, int &stopServerResponse);

        /// Web service operation 'resetMonitorData' (returns error code or SOAP_OK)
        int resetMonitorData(std::string resetMonitorDataRequest, int &resetMonitorDataResponse);

        /// Web service operation 'sendUpdate' (returns error code or SOAP_OK)
        int sendUpdate(int sendUpdateRequest, struct ns1__sendUpdateResponse &_param_6);

        /// Web service operation 'getRunManagerModules' (returns error code or SOAP_OK)
        int getRunManagerModules(std::string daqid, struct ns1__getRunManagerModulesResponse &_param_7);
};

#endif /* DAQPPSERVICE_H_ */
