#include "pydaqpp.h"
#include <iostream>
#include <DAQ++/DAQid.h>
#include "pydaqpp.h"
#include "pydaqpp_types.h"

using namespace DAQpp;


static PyMethodDef daqid_methods[] = {
    {NULL}  /* Sentinel */
};

static PyMemberDef daqid_members[] = {
    {NULL}  /* Sentinel */
};

static PyObject *
daqid_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
   daqpp_DAQid *self;
   self =  PyObject_New(daqpp_DAQid,type);
   if (self!=NULL) {
      self->id  = 0;
      self->dict = PyDict_New();
   }
   return (PyObject *)self;
}

static void
daqid_dealloc(daqpp_DAQid* self)
{
   delete self->id;
   Py_DECREF(self->dict);
   self->id = 0;
   self->ob_type->tp_free((PyObject*)self);
}


static PyObject *
daqid_call(daqpp_DAQid* self,PyObject *args, PyObject *other) {
   PyObject *out = PyString_FromString((const char *)(*self->id));
   return out;
}


static int
daqid_init(daqpp_DAQid *self, PyObject *args, PyObject *kwargs) {
   PyObject *in=Py_None;
   PyObject *str;

   if (!PyArg_ParseTuple(args,"O",&in))
      return -1;

   if ( in!=Py_None) {
      str = PyObject_Str( in );
      if (str) {
	 if ( PyString_Check(in) ) {
	    std::string v = PyString_AsString(str);
	    self->id = new  DAQid(v);
	 }
	 Py_DECREF(str);
      }
   }

   return 0;
}

static PyObject *
daqid_str(daqpp_DAQid *self) {
   PyObject *out = PyString_FromString((const char *)(*self->id));
   return out;
}

static PyTypeObject DAQid_Type = {
   PyObject_HEAD_INIT(NULL)
   0,                         /*ob_size*/
   "daqpp.DAQid",             /*tp_name*/
   sizeof(daqpp_DAQid),       /*tp_basicsize*/
   0,                         /*tp_itemsize*/
   (destructor)daqid_dealloc,                         /*tp_dealloc*/
   0,                         /*tp_print*/
   0,                         /*tp_getattr*/
   0,                         /*tp_setattr*/
   0,                         /*tp_compare*/
   (reprfunc)0,                         /*tp_repr*/
   0,                         /*tp_as_number*/
   0,                         /*tp_as_sequence*/
   0,                         /*tp_as_mapping*/
   0,                         /*tp_hash */
   (ternaryfunc)daqid_call,                         /*tp_call*/
   (reprfunc)daqid_str,                 /*tp_str*/
   PyObject_GenericGetAttr,                         /*tp_getattro*/
   PyObject_GenericSetAttr,                         /*tp_setattro*/
   0,                         /*tp_as_buffer*/
   Py_TPFLAGS_DEFAULT| Py_TPFLAGS_BASETYPE,        /*tp_flags*/
   "DAQid wrapper",           /* tp_doc */
       0,		               /* tp_traverse */
    0,		               /* tp_clear */
    0,		               /* tp_richcompare */
    0,		               /* tp_weaklistoffset */
    0,		               /* tp_iter */
    0,		               /* tp_iternext */
    daqid_methods,             /* tp_methods */
    daqid_members,             /* tp_members */
    0,                         /* tp_getset */
    0,                         /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    offsetof(daqpp_DAQid, dict),                         /* tp_dictoffset */
    (initproc)daqid_init,      /* tp_init */
    0,                         /* tp_alloc */
    daqid_new,                 /* tp_new */
};

int PyDAQpp_DAQid_Check(PyObject *O)
{
    return PyType_IsSubtype(O->ob_type, &DAQid_Type);
}

PyObject *PyDAQpp_DAQid_New(const char *val) {
   daqpp_DAQid *ret;
   ret = PyObject_New(daqpp_DAQid,&DAQid_Type);
   if (ret == NULL)
   {
      //daqpp_print_error();
      return PyErr_NoMemory();
   }
   std::string sid(val ? val : "");

   ret->id = new  DAQid(sid);
   ret->dict = PyDict_New();
   return (PyObject *)ret;
}

void register_daqid(PyObject *dict) {
   daqpp_register_class(dict,"DAQid",
			&DAQid_Type,
			0);
}
