/* -*- mode: c++ -*- */
#ifndef __importSequence_h__
#define __importSequence_h__

#include <exception>
#include <string>
#include <Python.h>
#if (PY_VERSION_HEX < 0x02050000)
typedef int Py_ssize_t;
#endif

class SeqException : public std::exception
{
    protected:
        std::string _why;
    public:
        SeqException(const std::string &msg) : _why(msg)
        {
        }
        SeqException(const SeqException &e)
        {
            _why = e._why;
        }
        virtual ~SeqException() throw()
        {
        }
        const char* what() const throw()
        {
            if (_why.empty() )
                return "SeqException";
            else
                return _why.c_str();
        }
};

char *import_sequence(PyObject *obj, Py_ssize_t &size, char tp=0) throw(SeqException);

#endif
