#include "pydaqpp_trigger.h"
#include "DAQobserver.h"
#include "pydaqpp_types.h"
#include "pydaqpp_debug.h"

bool pyDAQtrigger::running=false;

pyDAQtrigger::pyDAQtrigger(PyObject *obj) :
    pyfunc(obj)
{
    Py_INCREF(obj);
}
bool pyDAQtrigger::operator()()
{
    bool rc = false;
    WHOAMI;
    if (running && DAQpp::DAQmanager::theDAQmanager()->isRunning())
    {
#if defined(DAQpp_DEBUG)
        info_msg("...still running\n");
#endif
        PyGILState_STATE gs = PyGILState_Ensure();
        PyObject *result = PyEval_CallObject(pyfunc,NULL);
        if (result)
        {
            rc = bool(PyInt_AsLong(result));
            Py_DECREF(result);
        }
        else
        {
            //std::cout << "Unknown problem in DAQtrigger::operator()" << std::endl;
        }
        PyGILState_Release(gs);
    }
    return rc;
}
pyDAQtrigger *theTrigger=0;
