/* -*- mode: c++ -*- */
#ifndef __daqpp_pydaqpp_types_h__
#define __daqpp_pydaqpp_types_h__

#include <DAQ++/ObserverModel.h>
#include <Python.h>

namespace DAQpp
{
    class DAQid;
    class ParameterHolder;
    class Module;
    class RunManager;
    class Monitor;
    class RunState;
    class Observable;
}


typedef struct
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    PyObject    *dict;
    DAQpp::DAQid *id;
}daqpp_DAQid;

#define OBSERVABLE(O) ((daqpp_Observable*)(O))->obs
typedef struct
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    PyObject    *dict;
    Observable *obs; // A DAQ++ Observable
}daqpp_Observable;
extern PyTypeObject Observable_Type;

#define PARAM_HOLDER(H) ((daqpp_ParamHolder*)(H))->h
typedef struct
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    PyObject    *dict;
    DAQpp::ParameterHolder *h; // A DAQ++ Parameter holder
}daqpp_ParamHolder;
extern PyTypeObject ParamHolder_Type;

#define MODULE(M) ((daqpp_Module*)(M))->m
#define PyMODULE(M) dynamic_cast<pyModule *>(MODULE((M)))
typedef struct
{
    daqpp_ParamHolder pH;
    /* Type-specific fields go here. */
    DAQpp::Module *m; // A DAQ++ Module
} daqpp_Module;
extern PyTypeObject Module_Type;
int setup_daqpp_module(DAQpp::Module *, daqpp_Module *);
void terminate_daqpp_module(daqpp_Module *self);

#define RUN_MANAGER(M) ((daqpp_RunManager*)(M))->m
#define PyRUN_MANAGER(M) dynamic_cast<pyRunManager *>(RUN_MANAGER((M)))
typedef struct
{
    daqpp_ParamHolder pH;
    /* Type-specific fields go here. */
    DAQpp::RunManager *m; // A DAQ++ Module
} daqpp_RunManager;
extern PyTypeObject RunManager_Type;
int setup_daqpp_runmanager(DAQpp::RunManager *, daqpp_RunManager *);

#define MONITOR(M) ((daqpp_Monitor *)M)->m
#define PyMONITOR(M) dynamic_cast<pyMonitor *>(MONITOR((M)))
typedef struct
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    PyObject    *dict;
    DAQpp::Monitor *m; // A DAQ++ Monitor
    int timeout;
}daqpp_Monitor;

#define RUN_STATE(R) ((daqpp_RunState*)R)->state
typedef struct
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    PyObject    *dict;
    DAQpp::RunState *state;
}daqpp_RunState;

#endif
