#ifndef __MyModule_h__
#define __MyModule_h__

#include <memory>
#include <DAQ++/Module.h>


//////////////////////////////////////////////////////////////////////////
// MyModule
//
//     This is the implementation of a Module.
//     We have to define all the DAQ operations. It will simulate random
//     data
//
//////////////////////////////////////////////////////////////////////////
class MyModule : public DAQpp::Module
{
public:
    MyModule(DAQpp::DAQid const id, int sz = 131);

    ~MyModule()
    {}

    void set_eff(double x, bool notify=false);
    void set_capacity(int x, bool notify=false);
    double get_eff();
    int get_capacity();

    // Prepare for a new run
    int PrepareForRun();
    // Start the run
    int Start(int mode = 0);
    // Stop the run
    int Stop(int mode = 0);
    // Pause the run
    int Pause();
    // Resume the run after pause
    int Continue();
    // Send a reset to the module
    int Reset();
    // Initialize the Module
    int GetReady();
    // Issues a trigger
    int Trigger()
    {
        return 0;
    };
    // Flush any remaining data on the Module
    void flush()
    {
        return;
    };
    // Returns true if the Module has data available
    bool hasData();
    char *getData(int &size);

};


#endif
