#ifndef __PythonLoader_h__
#define __PythonLoader_h__
#include <map>
#include <stack>
#include <string>
#include <Python.h>
#include <DAQ++/Module.h>
#include <DAQ++/RunManager.h>
/**
 * This class handles the interaction with python
 */
class PythonLoader
{
    protected:
        PythonLoader();
        PythonLoader(const PythonLoader &);
        
        typedef std::map<std::string, PyObject *> ObjectList;
        ObjectList ModuleList;
        ObjectList MethodList;
        static PythonLoader __the_loader;
        PyThreadState *_save;
        std::stack<PyGILState_STATE> gstate;
        
        PyObject *load_module(const std::string &module, const std::string &method);
    public:
        static PythonLoader &getInstance();
        virtual ~PythonLoader();
        
        DAQpp::Module *create_module(const DAQpp::DAQid &id, const std::string &module, const std::string &method);
        DAQpp::RunManager *create_run_manager(const DAQpp::DAQid &id, const std::string &module, const std::string &method);
        
//        void allow_threads();
//        void disable_threads();
//        void wait(double seconds);
};

#endif /*__PythonLoader_h__*/
