#!/usr/bin/env python

import random
import array
import time
import daqpp

from simpleMonitor import MyMonitor
from simpleModule import MyModule

class MyTrigger(object):
    def __init__(self,freq):
        self.freq = freq
        print "new Trigger: ",self.freq

    def __call__(self):
        xx = (random.random() < self.freq)
        return xx

class Rmanager(daqpp.RunManager):
    def __init__(self,id):
        super(Rmanager,self).__init__(id)
        self.cntr = 0
        monitor = MyMonitor()
        self.set_monitor(monitor)
        
    def GetReady(self):
        print self.get_id(),"-> GetReady"
        daqpp.RunManager.GetReady(self)

    def PrepareForRun(self):
        print self.get_id(),"-> PrepareForRun"
        daqpp.RunManager.PrepareForRun(self)

    def EndOfRun(self):
        print self.get_id(),"-> EndOfRun"
        daqpp.RunManager.EndOfRun(self)

    def writeData(self, buff):
        return len(buff)


def test():
    rm   = Rmanager("main");

    theTrigger = MyTrigger(2)
    daqpp.set_trigger(theTrigger)

    rm.addModule( MyModule("m.1",512) )
    rm.addModule( MyModule("m.2",256) )

    print "Number of modules in ",rm.get_id(),"is",rm.countModules()
    print "Number of modules in DAQmanager",daqpp.countModules()

    rm.Activate()
    #rm.set_MxEvts(-1)
    rm.set_max_events(100000)

    print "Starting run"
    try:
        daqpp.StartRun(0)
#    try:
#        while rm.GetStatus().time()<5.:
#            daqm.wait(100000)
#            print '\r%s' % rm.GetStatus(),
            
    except KeyboardInterrupt:
        print "\nRun interrupted"
        
    print "\n\nDone"
    daqpp.StopRun()
    print "done"


if __name__=='__main__':
    test()

    
#--------------------------------------------------------------------------------------------------
