#!/usr/bin/env python

""" We implement here a very simple module
"""
import daqpp
import array
import random
import Histogram


class MyModule(daqpp.Module):
    """ This is a very simple module that defines a global buffer
        for storing the data.
    """
    def __init__(self,id,size=1024):
        super(MyModule,self).__init__(id)
        self.size = size
        self.data_buffer = array.array('c',['\0' for x in range(0,size)])
        #self.data_buffer = daqpp.Buffer('c',size)

        mean = 5.0
        std  = 1.0
        self.add_par("random", True )
        self.add_par("mean", mean)
        self.add_par("std", std)
        self.add_par("pedestals", [ 0 for x in range(0,128)])
        self.cntr = 0
        self.hst = Histogram.Histogram(id, "gauss", 100, mean-5.0*std, mean+5.0*std)

    def PrepareForRun(self):
        print self.get_id(),"\t+-> PrepareForRun"
        return 1

    def Start(self,mode):
        print self.get_id(),"\t+-> Start",mode
        return 1

    def Stop(self,mode):
        print self.get_id(),"\t+-> Stop",mode
        return 1

    def hasData(self):
        return True

    def getData(self):
        self.cntr += 1
        self.hst.fill ( random.gauss( self.get_par("mean"), self.get_par("std") ))
        return self.data_buffer;

    def get_monitor_data(self):
        return self.hst.write()

def create_module(name):
    print 'Creating module',name
    md = MyModule(name)