#!/usr/bin/env python

""" We implement here a very simple monitor that dumps to the
    standard output the state of the run manager at fixed time
    intervals
"""
import daqpp


class MyMonitor(daqpp.Monitor):
    def __init__(self):
        """ We initialize the instance here
        """
        super(MyMonitor,self).__init__()
        self.timer = daqpp.GTimer()
        self.nevts = 0

    def on_start(self):
        """ This is called by DAQpp::Monitor::start_monitor and
            is used to make any initialization prior the the monitoring
            process
        """
        print '### Starting monitor'
        self.nevts = 0
        self.timer.start()
        
    def on_stop(self):
        """ This is called from DAQpp::Monitor::stop_monitor
        """
        print '### Stopping monitor. %d events monitored' % self.nevts
        self.timer.stop()
        
        
    def run(self,buff):
        """ This is executed in the monitoring thread every time there
            is new data in the Monitor buffer
        """
        self.nevts += 1
        if self.timer()>0.1:
            self.timer.reset()
            print '\r%s' % self.get_runmanager().GetStatus(),
            sys.stdout.flush()
            
        return
