#!/usr/bin/env python
"""
soapServer.py

 Created on: Jan 10, 2011
     Author: lacasta
"""

import time
import daqpp
from simpleModule import MyModule
from simpleRunManager import Rmanager
from MsgManager import MsgManager

    
def main():
    # Add the MsgManager as Observer
    daqpp.add_observer(MsgManager())
    
    # Set up DAQ
    rm   = Rmanager("main");
    rm.addModule( MyModule("m.1",512) )
    rm.addModule( MyModule("m.2",512) )
    rm.addModule( MyModule("m.3",512) )
    rm.addModule( daqpp.create_module('m.X', "create_module", "libmodule.so") )

    if not daqpp.start_soap_server(50000, True):
        print "Could not start the server"
        return
    

    
    rm.set_max_events(0)
    daqpp.StartRun(daqpp.Loop)
    
    
    try:
        while True:
            time.sleep(1.0)
    except KeyboardInterrupt:
        print "Arrrggg !!!!"
        print "Stopping the server..."
        daqpp.stop_soap_server()
        print "...done"
        
    daqpp.StopRun()
    print "Quitting"

if __name__ == "__main__":
    main()
