#!/usr/bin/env python
"""
    We test here the Fifo object
"""
import sys

import time


import threading
import random
from array import array
from daqpp import Fifo, GTimer


class loop:
    def __init__(self,delay):
        self.delay=delay

    def __call__(self,usec):
        i=0
        while i<self.delay:
            i += 1

    
A = array('i')

class MyThread(threading.Thread):
    """ This is a threading class that will 'sleep'
        until there is some data to read from the 
        Fifo
    """
    def __init__(self,fifo):
        threading.Thread.__init__(self,target=self.doit)
        self.fifo = fifo
        self.ya=0
        self.data=0

    def doit(self):
        """ We try to read data from the Fifo here.
            When calling the Fifo.read method it will
            sleep until there is some data there
        """
        if self.fifo==None:
            print 'I need a real fifo'
            return

        print '**** Starting the Reading thread '
        while 1:
            self.ya = 1
            b = self.fifo.read(4)
            b.type = 'i'
            sz = b[0]
            self.data=sz
            if sz==-1:
                break

            b = self.fifo.read(sz*b.itemsize)

            print '<<< read: size',sz,' buffer len ',b.size,'len(b)=',len(b)




def main():
    fifo = Fifo(0x400)
    T = MyThread(fifo)
    g = GTimer()

    print  'Thread is Alive:',T.isAlive()
    T.start()

    ntimes = 10
    delay  = 1.
    print 'Writing %d times to the Fifo' % (ntimes,)
    print 'I will sleep for %f sec. between writings' % (delay,)
    g.start()
    try:
        
        print  'Thread is Alive:',T.isAlive()

        for i in range(0,ntimes):
            sz = int(random.randint(10,128))
            print '>>> %d.- writing sz %d words (%d)' %(i,sz, sz*4)
            buff = [sz,]
            for x in range(0,sz):
                buff.append(int(x))
            fifo.write(array('i',buff))
            g.reset()
            while g() < delay: 
                sys.stdout.write(".")
                sys.stdout.flush()
                g.wait(delay/10.)
            sys.stdout.write("\n")
            sys.stdout.flush()   
            
            
    except KeyboardInterrupt:
        fifo.write(array('i',[-1,]))
                   
    fifo.write(array('i',[-1,]))
    print 'Waiting Thread to die...'
    T.join()
    print '...done'
    

if __name__=='__main__':
    main()

#--------------------------------------------------------------------------
