#!/usr/bin/env python

import sys

import os, gtk,gobject
import gtkhst
import daqpp
from gtktools import SpinSlider,RunMenu


class MyRunMenu(RunMenu):
    def __init__(self, runState):
        super(MyRunMenu,self).__init__()
        self.subscribe(runState)

    def subscribe(self,runState):
        self.rstate = runState
        if runState:
            runState.addObserver( self )

    def command(self,w,command):
        if not self.rstate:
            return

        if command==self.notready or command==self.reset:
            self.rstate.set_status(daqpp.NotReady)
        elif command==self.getready:
            self.rstate.set_status(daqpp.Ready)
        elif command==self.run or command==self.resume:
            self.rstate.set_status(daqpp.Running)
        elif command==self.stop:
            self.rstate.set_status(daqpp.Ready)
        elif command==self.pause:
            self.rstate.set_status(daqpp.Paused)
        else:
            print 'MyRunMenu.command: Unhandled command',command


    def update(self,arg):
        self.set_state(arg)

class MainWindow(dict):
    def __init__(self):
        self.create()

    def __getattr__(self, data_name):
        if data_name in self:
            data = self[data_name]
            return data
        else:
            widget = self.window.get_data(data_name)
            if widget != None:
                self[data_name] = widget
                return widget
            else:
                raise AttributeError, data_name
                        
    def __setattr__(self, name, value):
        self[name] = value
            
    def new_value(self,spl):
        print 'new value',spl.get_value()
            
    def create(self):
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.set_title("testGtk");
        self.window.connect('delete_event',self.gtk_true)

        vbox = gtk.VBox(False,1)
        self.window.add(vbox)
        self.window.set_data('vbox',vbox)

        #
        # Create the spin slider
        #
        self.spl = SpinSlider(0.,0., 100., 1., 10., 0.)
        vbox.pack_start(self.spl,False,True)

        self.spl.connect("value_changed",self.new_value)
        self.spl.set_size_request(200,-1)


        self.runm = MyRunMenu(None)
        vbox.pack_start(self.runm,False,True)

        btnbox = gtk.HButtonBox()
        btnbox.show()
        vbox.pack_start(btnbox,False,True)
        
        btn = gtk.Button(stock=gtk.STOCK_OK)
        btn.connect('clicked',self.gtk_main_quit)
        
        btnbox.pack_start(btn)
        
        
        self.window.show_all()
        


    def gtk_true(self, *args):
        return True
	
    def gtk_false(self, *args):
        return False
	
    def gtk_main_quit(self, *args):
        gtk.main_quit()
		
    def main(self):
        gtk.main()

    def quit(self):
        gtk.main_quit()

    def run(self):
        try:
            self.main()
        except KeyboardInterrupt:
            self.on_keyboard_interrupt()


    def on_keyboard_interrupt(self):
         pass       

def main():
    rstate = daqpp.RunState()
    window = MainWindow()
    window.runm.subscribe(rstate)
    
    window.run()


if __name__ == "__main__":
    main()


#-------------------------------------------------------------------------
