#!/usr/bin/env python
import sys
import daqpp


class ParObserver(object):
    def __init__(self, par, ff, *args):
        self.par = par
        self.func = ff
        self.args = args
        self.par.addObserver(self)

    def update(self, val):
        self.func(val, self.args)


def spy_1(val, *args):
    print 'From spy_1: val=%s' % str(val)

def spy_2(val, *args):
    print 'From spy_2: val=%s' % str(val)
    

class MyModule(daqpp.Module):
    def __init__(self,id,eff=0.5,size=256):
        daqpp.Module.__init__(self,id)
        self.eff = eff

    def hasData(self):
        return True

    def getData(self):
        return [];

def test(): 
    mm = MyModule('kk')

    p1 = 3.5
    pnew = 7.5
    print 'adding parameter p1 with value',p1
    mm.add_par("p1",p1)
    print '...done'
    print "p1 is",mm.get_par("p1")
    print 'Changing the parameter to',pnew
    mm.set_par("p1",pnew)
    print '...done'
    print "p1 is now",mm.get_par("p1")

    p2 = 35
    print 'adding parameter p2 with value',p1
    mm.add_par("p2",p2)
    print "p2 is",mm.get_par("p2")

    print 'Checking if it has parameter p2'
    print 'has_par(p2):', mm.has_par('p2')
    print 'has_par(pxx):', mm.has_par('pxx')

    vv = (0,1,2,3,4)
    print 'trying to add a tuple'
    try:
        mm.add_par('tuple',vv)
        print '...done'
        print 'Now get it back'
        print mm.get_par("tuple")
        print 'Now change it to something different'
        d = {'Hola':1,'que':2,'tal':3}
        mm.set_par('tuple',d)
        print '...done'
        print mm.get_par("tuple")
        print 'Another try'
        mm.set_par('tuple',[0,1,2])
        print mm.get_par("tuple")
    except daqpp.DAQError,e:
        print 'Failed. Reason:',e


    print 'Now we test the Observable interface of Parameters'
    vv = (2,4,6)
    sp1 = ParObserver(mm.find_par('tuple'), spy_1)
    print 'Changing tuple to',vv
    mm.set_par('tuple',vv,True)

    pnew = 12
    sp2 = ParObserver(mm.find_par('p2'), spy_2)
    print 'Changing p2 to ',pnew
    mm.set_par('p2',pnew,True)
    
    print "done"

if __name__=="__main__":
    test()

#--------------------------------------------------------------------------
