#!/usr/bin/env python
import sys
import daqpp
import random

class Observer:
    def __init__(self):
        pass

    def update(self,arg):
        print "Observer: State is ",
        if arg==daqpp.Ready:
            print "Ready"
        elif arg==daqpp.NotReady:
            print "NotReady"
        elif arg==daqpp.Starting:
            print "Starting"
        elif arg==daqpp.Paused:
            print "Paused"
        elif arg==daqpp.Running:
            print "Running"
        elif arg==daqpp.Stopping:
            print "Stopping"
        elif arg==daqpp.TimeOut:
            print "TimeOut"
        else:
            print "Unknown [",arg,"]"


r = daqpp.RunState()
r.set_name('rs')
print "name: ",r.get_name()

obs = Observer()
r.addObserver( obs )

nevt = 1000
eff  = 0.75
print 'Acquiring',nevt,'with an eff. of',eff
r.start()
for x in range(0,nevt):
    r.new_trigger()
    if random.random()<eff:
        r.new_written()

r.stop()
print r

print "Testing Observers"
r.set_status(daqpp.NotDefined)
r.set_status(daqpp.NotReady)
r.set_status(daqpp.Ready)
r.set_status(daqpp.Starting)
r.set_status(daqpp.Running)
r.set_status(daqpp.Paused)
r.set_status(daqpp.Stopping)
r.set_status(daqpp.Ready)

#------------------------------------------------------------------
