#ifndef __MyModule_h__
#define __MyModule_h__

#include <memory>
#include <DAQ++/Module.h>

//////////////////////////////////////////////////////////////////////////
// MyModule
//
//     This is the implementation of a Module.
//     We have to define all the DAQ operations. It will simulate random
//     data
//
//////////////////////////////////////////////////////////////////////////
class MyModule: public DAQpp::Module
{
    private:
        int capacity;
        double eff;

    public:
        MyModule(DAQpp::DAQid const id, int sz = 131) :
            Module(id), capacity(sz), eff(1.)
        {
        }

        ~MyModule()
        {
        }

        void set_eff(double x)
        {
            eff = x;
        }
        double get_eff()
        {
            return eff;
        }

        // Prepare for a new run
        int PrepareForRun()
        {
            return 0;
        }
        // Start the run
        int Start(int mode = 0)
        {
            return 0;
        }
        ;
        // Stop the run
        int Stop(int mode = 0)
        {
            return 0;
        }
        ;
        // Pause the run
        int Pause()
        {
            return 0;
        }
        ;
        // Resume the run after pause
        int Continue()
        {
            return 0;
        }
        ;
        // Send a reset to the module
        int Reset()
        {
            return 0;
        }
        ;
        // Initialize the Module
        int GetReady()
        {
            return 0;
        }
        ;
        // Issues a trigger
        int Trigger()
        {
            return 0;
        }
        ;
        // Flush any remaining data on the Module
        void flush()
        {
            return;
        }
        ;
        // Returns true if the Module has data available
        bool hasData();
        char *getData(int &size);

};

#endif
