#include <iostream>
#include <DAQ++/logger.h>
#include "SimpleModule.h"
#include "random.h"

SimpleModule::SimpleModule(const DAQpp::DAQid &id)
    : DAQpp::Module(id)
{
    add_par("random", new DAQpp::Par<bool>(true),&id);
}

SimpleModule::~SimpleModule()
{
    std::cout << "*** Destroying Module " << get_id() << std::endl;
}

bool SimpleModule::hasData()
{
    return true;
}

char *SimpleModule::getData(int &size)
{
    const int nword = 1024;
    char *buffer;
            
    size = int(randflat(nword / 2, nword));
    buffer = allocate(size);
    return buffer;    
}


int SimpleModule::PrepareForRun ()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << "\t+-> Module.PrepareForRun [" << get_id() << "]"
       << std::endl;
    return 0;
}

int SimpleModule::Start (int rc)
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << "\t+-> Module.Start         [" << get_id() << "]"
       << std::endl;
    return 0;
}

int SimpleModule::Stop (int rc)
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << "\t+-> Module.Stop          [" << get_id() << "]"
       << std::endl;
    return 0;
}

int SimpleModule::Pause ()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << "\t+-> Module.Pause         [" << get_id() << "]"
       << std::endl;
    return 0;
}
int SimpleModule::Continue ()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << "\t+-> Module.Continue      [" << get_id() << "]"
       << std::endl;
    return 0;
}
int SimpleModule::Reset ()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << "\t+-> Module.Reset         [" << get_id() << "]"
       << std::endl;
    return 0;
}
int SimpleModule::GetReady ()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
    << "\t+-> Module.GetReady      [" << get_id() << "]"
    << std::endl;
    return 0;
}

int SimpleModule::Trigger ()
{
    return 0;
}
void SimpleModule::flush ()
{}
