#include <iostream>
#include <DAQ++/logger.h>
#include "SimpleRunManager.h"

SimpleRunManager::SimpleRunManager(const DAQpp::DAQid &id, DAQpp::RunCommand *rc)
    : DAQpp::RunManager(id, rc)
{
}

SimpleRunManager::~SimpleRunManager()
{
    std::cout << "*** Destroying RunManager " << get_id() << std::endl;
}


void SimpleRunManager::GetReady()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << get_id() << "-> GetReady" << std::endl;
    RunManager::GetReady();
}
void SimpleRunManager::PrepareForRun()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << get_id() << "-> Starting the run" << std::endl;
    RunManager::PrepareForRun();
}
void SimpleRunManager::EndOfRun()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << get_id() << "-> End of run" << std::endl;
    RunManager::EndOfRun();
}
void SimpleRunManager::Stop()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << get_id() << "-> Stop" << std::endl;
    RunManager::Stop();
}
void SimpleRunManager::Start()
{
    DAQpp::ostream os;
    os << DAQpp::loglevel(DAQpp::Log::info)
       << get_id() << "-> Start" << std::endl;
    RunManager::Start();
}
