/* -*- mode: c++ -*- */
#ifndef __DAQpp_test_Trigger_h__
#define __DAQpp_test_Trigger_h__
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/poll.h>
#include <fcntl.h>

#include <DAQ++/DAQmanager.h>

/*
 * This is the thread that will generate the trigger
 */
class Trigger: public DAQpp::Thread, public DAQpp::DAQTrigger
{
    private:
        int fd;
        double freq;
        double period;
        std::string fname;
        struct pollfd fdlist;

        bool running;
    public:
        Trigger(double freq = 50.);
        ~Trigger();
        std::string get_file_name() const
        {
            return fname;
        }
        int get_fd() const
        {
            return fd;
        }
        void set_freq(double x = -1);
        double get_freq()
        {
            return freq;
        }
        void loop();
        void run();

        void enableInterrupts();
        void disableInterrupts();
        bool operator()();

};

#endif
